﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace csharpdemo
{
    public partial class FrmUnitProperty : Form
    {
        public FrmUnitProperty()
        {
            InitializeComponent();
        }

        private void FrmUnitProperty_Load(object sender, EventArgs e)
        {
            vg1.Design("http://www.visual-graph.com/activex/unit.xml");

        }

        private void btnSetLine_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.get_Units(0);
            d.Execute("LineColor = $FF; LineWidth = 8; LineType = 15; EndArrow = 1");
        }

        private void btnSetPoints_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.get_Units(0);
            d.Execute("PointCount=4; x[1]=-300; Y[1]=-150; x[2]=-200; Y[2]=-250; Refresh()");
        }

        private void btnSetFont_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("rect1");
            d.Execute("Text = 'Wellcom to use Visual Graph!'; FontName = 'Times new Roman'; FontSize = 24; FontStyle = 1;");
        }

        private void btnSetPattern1_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("circle1");
            d.Execute( "Pattern=1; BackColor = $FF;Picture=''" );
        }

        private void btnSetPattern19_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("circle1");
            d.Execute( "Pattern=19; BackColor = $FF;Picture=''" );
        }

        private void btnSetPattern242_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("circle1");
            d.Execute( "Pattern=242;Picture=''" );
        }

        private void btnSetPattern254_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet;
            d.Execute("Circle1.Pattern=254;Circle1.Picture=Rect2.Picture");
        }

        private void btnSetPattern255_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet;
            d.Execute("Circle1.Pattern=255;Circle1.Picture=Rect2.Picture");
        }

        private void btnSetPattern0_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet;
            d.Execute("Circle1.Pattern=0;Circle1.Picture=Rect2.Picture;Circle1.BackColor=$C0C0C0");
        }

        private void btnShowShadow_Click(object sender, EventArgs e)
        {
            var i = 0;
            var n = vg1.vg.ActiveSheet.UnitCount;
            while (i < n)
            {
                var d = vg1.vg.ActiveSheet.get_Units(i);
                d.ShadowOffsetX = 10;
                d.ShadowOffsetY = 10;
                d.ShadowAlpha = 50;
                d.ShadowColor = 0;
                d.ShadowVisible = true;
                i = i + 1;
            }
        }

        private void btnHideShadow_Click(object sender, EventArgs e)
        {
            var i = 0;
            var n = vg1.vg.ActiveSheet.UnitCount;
            while (i < n)
            {
                var d = vg1.vg.ActiveSheet.get_Units(i);
                d.ShadowVisible = false;
                i = i + 1;
            }

        }

        private void btnChangeAngle1_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("element1");
            var el = d.UnitByName("line3");
            el.Angle = el.Angle + 15;
            d.Refresh();
        }

        private void btnChangeAngle2_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("element1");
            d.Angle = d.Angle + 15;
        }

        private void btnChangeAngle3_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet;
            d.Angle = d.Angle + 15;

        }

        private void btnLineparent_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("element1");
            var line = d.UnitByName("line1");
            MessageBox.Show("Parent of the arrow line is : " + line.Parent.Name);
        }

        private void btnElementparent_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("element1");
            MessageBox.Show("Parent of the element is : " + d.Parent.Name);

        }

        private void btnSheetParent_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet;
            MessageBox.Show("Parent of the sheet is : " + d.Parent);
        }

        private void btnOwner1_Click(object sender, EventArgs e)
        {
            var d = vg1.vg.ActiveSheet.UnitByName("element1");
            MessageBox.Show("the file name is : " + ((vg.Ivg)d.Owner).FileName);
        }

        private void btnShowHint_Click(object sender, EventArgs e)
        {
            var i = 0;
            while (i < vg1.vg.ActiveSheet.UnitCount)
            {
                var d = vg1.vg.ActiveSheet.get_Units(i);
                d.ShowHint = true;
                i = i + 1;
            }

        }

        private void btnHideHint_Click(object sender, EventArgs e)
        {
            var i = 0;
            while (i < vg1.vg.ActiveSheet.UnitCount)
            {
                var d = vg1.vg.ActiveSheet.get_Units(i);
                d.ShowHint = false;
                i = i + 1;
            }
        }

        private void btnShowUnits_Click(object sender, EventArgs e)
        {
            var i = 0;
            var n = vg1.vg.ActiveSheet.UnitCount;
            while (i < n)
            {
                var d = vg1.vg.ActiveSheet.get_Units(i);
                vg1.vg.Selection.Clear();
                vg1.vg.Selection.Add(d);
                MessageBox.Show("Units[" + i + "] is '" + d.Name + "', its Type property is '" + d.Type + "'");
                i = i + 1;
            }
        }
    }
}
