﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace csharpdemo
{
    public partial class FrmUseunitLink : Form
    {
        public FrmUseunitLink()
        {
            InitializeComponent();
        }

        private void FrmUseunitLink_Load(object sender, EventArgs e)
        {
            vg1.Design("http://www.visual-graph.com/activex/link.xml");
        }

        private void btnSetlink_Click(object sender, EventArgs e)
        {
            var sheet = vg1.vg.ActiveSheet;
            var d1 = vg1.vg.ActiveSheet.UnitByName("HKnife1");
            var d2 = vg1.vg.ActiveSheet.UnitByName("TransformerB1");
            var d3 = vg1.vg.ActiveSheet.UnitByName("HSwitch1");
            var Line1 = vg1.vg.ActiveSheet.UnitByName("Line1");

            var line = vg1.vg.ActiveSheet.AddUnit(null, "line");
            line.Execute("PointCount = 3; LinkMode = 1; Bytes[1] = 8; Bytes[2] = 8");
            sheet.SetLink(d1, line, "L2", "P0");
            sheet.SetLink(line, d2, "P1", "L1");

            line = vg1.vg.ActiveSheet.AddUnit(null, "line");
            line.Execute("PointCount = 3; LinkMode = 1; Bytes[1] = 8; Bytes[2] = 8");
            sheet.SetLink(d2, line, "L3", "P0");
            sheet.SetLink(line, d3, "P1", "L1");

            line = vg1.vg.ActiveSheet.AddUnit(null, "line");
            line.Execute("PointCount = 2; LinkMode = 1; Bytes[1] = 8");
            sheet.SetLink(d2, line, "L2", "P0");
            line.Execute("X[2] = X[0]");
            sheet.SetLink(line, Line1, "P1", "");

            d1.Refresh();
            d2.Refresh();
            d3.Refresh();
        }

        private void btnGetLinkRelationship_Click(object sender, EventArgs e)
        {
            var i = 0;
            var n = vg1.vg.ActiveSheet.UnitCount;
            while (i < n)
            {
                var d = vg1.vg.ActiveSheet.get_Units(i);
                var j = 0;
                while (j < d.LinkCount)
                {
                    var el = d.get_Links(j);
                    var ft = d.get_LinkFoots(j);
                    vg1.vg.Selection.Clear();
                    vg1.vg.Selection.Add(d);
                    MessageBox.Show("Unit " + d.Name + " links to: " + el.Name + " at postion: " + ft);
                    j = j + 1;
                }
                i = i + 1;
            }
        }
    }
}
